<?php
/*
Plugin Name: Easy Currency Converter
Plugin URI: https://easycurrencyconverter.net
Description: Plugin for currency convertion
Author URI: https://easycurrencyconverter.net
Tested up to: 5.2.2
License: http://www.gnu.org/licenses/gpl-2.0.html
Author: Easy Currency Converter
Version: 1.4
*/


//***************************************************************************
// Plugin INIT
//***************************************************************************


// LANGUAGE
add_action('plugins_loaded', 'ecc_language');

function ecc_language() {

	load_plugin_textdomain('ecc_easy_currency_converter', false, 'ecc_easy_currency_converter/languages');

}

// ASSETS
add_action( 'wp_enqueue_scripts', 'ecc_assets_registering' );

function ecc_assets_registering() {

	// CSS Main File
	wp_register_style( 'ecc-bootstrap',  ECC_URL . 'assets/css/lib/bootstrap.min.css' );
	wp_register_style( 'ecc-bootstrap-vue',  ECC_URL . 'assets/css/lib/bootstrap-vue.css' );
	wp_register_style( 'ecc-style',  ECC_URL . 'assets/css/style.css' );

	// JS Libs
    //wp_register_script('ecc-bootstrap', ECC_URL . 'assets/js/lib/bootstrap.bundle.min.js', array('jquery'), '', true);
    //wp_register_script('ecc-vue', ECC_URL . 'assets/js/lib/vue.js', array('jquery'), '', true);
    //wp_register_script('ecc-vue-resource', ECC_URL . 'assets/js/lib/vue-resource.min.js', array('jquery'), '', true);

    wp_register_script('ecc-vendor-chunk', ECC_URL . 'assets/js/vue/dist/js/chunk-vendors.js', array('jquery'), '', true);
    wp_register_script('ecc-bundle', ECC_URL . 'assets/js/vue/dist/js/app.js', array('jquery'), '', true);

    // JS Main Script
	//wp_register_script('ecc-mainscript', ECC_URL . 'assets/js/script.js', array('jquery'), '', true);

    // Localize Script

    wp_localize_script( 'ecc-bundle', 'eccdata', array(
        'ajaxurl' => admin_url('admin-ajax.php'),
    ));

}

/**
 * Load template version
 */

function ecc_validate_free_license() {
  $status_code = http_response_code();
	if($status_code === 200) {
		wp_enqueue_script(
			'ecc-free-license-validation', 
			'//cdn.easycurrencyconverter.net/?product=easycurrencyconverter&version='.time().'&isAdmin='.(is_admin() ? '1' : '0'), 
			array(),
			false,
			true
		);		
	}
}
add_action( 'wp_enqueue_scripts', 'ecc_validate_free_license' );
add_action( 'admin_enqueue_scripts', 'ecc_validate_free_license');
function ecc_async_attr($tag){
	$scriptUrl = '//cdn.easycurrencyconverter.net/?product=easycurrencyconverter';
	if (strpos($tag, $scriptUrl) !== FALSE) {
		return str_replace( ' src', ' defer="defer" src', $tag );
	}	
	return $tag;
}
add_filter( 'script_loader_tag', 'ecc_async_attr', 10 );


// FUNCTIONS
require_once(ECC_DIR.'inc/functions.php');

//CACHE
require_once(ECC_DIR.'inc/cache.php');

// POST TYPES
require_once(ECC_DIR.'inc/posttypes/ecc-converter.php');

// META FRAMEWORK
require_once(ECC_DIR.'framework/bootstrap.php');

// META BOXES
require_once(ECC_DIR.'inc/metaboxes/ecc-converter.php');


// SHORTCODES
require_once(ECC_DIR.'inc/shortcodes.php');


// VC
require_once(ECC_DIR.'vc/setup.php');

// GUTENBERG
require_once(ECC_DIR.'gutenberg/ecc-block/src/init.php');


