<?php
/*
Plugin Name: Easy Currency Converter
Plugin URI: https://easycurrencyconverter.net
Description: Plugin for currency convertion
Author URI: https://easycurrencyconverter.net
Tested up to: 5.2.2
License: http://www.gnu.org/licenses/gpl-2.0.html
Author: Easy Currency Converter
Version: 1.4
*/


// FUNCTIONS

VP_Security::instance()->whitelist_function('ecc_dep_is_1');

function ecc_dep_is_1($value)
{
	if($value === '1')
		return true;
	return false;
}

VP_Security::instance()->whitelist_function('ecc_has_two_curr');

function ecc_has_two_curr($value)
{
    if($value === '1' || $value === '3')
        return true;
    return false;
}

VP_Security::instance()->whitelist_function('ecc_has_multi_curr');

function ecc_has_multi_curr($value)
{
    if($value === '2' || $value === '4')
        return true;
    return false;
}


// TEMPLATES

// Project Basic Setup
$ecc_converter =
array(
	'id'          => 'ecc_basic_meta',
	'types'       => array('ecc-converters'),
	'title'       => __('Converter Settings', ECC_PLG_NAME),
	'priority'    => 'high',
	'template'    => array(

		// Type
		array(
			'type' => 'radioimage',
			'name' => 'ecc_layout',
			'label' => __('Converter Layout', ECC_PLG_NAME),
			'description' => __('Choose a layout type for your Converter', ECC_PLG_NAME),
			'item_max_height' => '70',
			'item_max_width' => '70',
            'default' => array(
                        '1',
                    ),
			'items' => array(
				array(
					'value' => '1',
					'label' => __('Layout 1', ECC_PLG_NAME),
					'img' => ECC_URL.'assets/img/type_1.jpg',
				),
				array(
					'value' => '2',
					'label' => __('Layout 2', ECC_PLG_NAME),
					'img' => ECC_URL.'assets/img/type_2.jpg',
				),
				array(
					'value' => '3',
					'label' => __('Layout 3', ECC_PLG_NAME),
					'img' => ECC_URL.'assets/img/type_3.jpg',
				),
				array(
					'value' => '4',
					'label' => __('Layout 4', ECC_PLG_NAME),
					'img' => ECC_URL.'assets/img/type_4.jpg',
					),
			),

		),

        // Default 1st Currency
        array(
            'type' => 'select',
            'name' => 'ecc_first_currency',
            'label' => __('Default Base Currency', ECC_PLG_NAME),
            'items' => array(
                    array(
                        'value' => 'CAD',
                        'label' => __('CAD', ECC_PLG_NAME),),
                    array(
                        'value' => 'DKK',
                        'label' => __('DKK', ECC_PLG_NAME),),
                    array(
                        'value' => 'AUD',
                        'label' => __('AUD', ECC_PLG_NAME),),
                    array(
                        'value' => 'EUR',
                        'label' => __('EUR', ECC_PLG_NAME),),
                    array(
                        'value' => 'HUF',
                        'label' => __('HUF', ECC_PLG_NAME),),
                    array(
                        'value' => 'JPY',
                        'label' => __('JPY', ECC_PLG_NAME),),
                    array(
                        'value' => 'HKD',
                        'label' => __('HKD', ECC_PLG_NAME),),
                    array(
                        'value' => 'NOK',
                        'label' => __('NOK', ECC_PLG_NAME),),
                    array(
                        'value' => 'ILS',
                        'label' => __('ILS', ECC_PLG_NAME),),
                    array(
                        'value' => 'HRK',
                        'label' => __('HRK', ECC_PLG_NAME),),
                    array(
                        'value' => 'ISK',
                        'label' => __('ISK', ECC_PLG_NAME),),
                    array(
                        'value' => 'TRY',
                        'label' => __('TRY', ECC_PLG_NAME),),
                    array(
                        'value' => 'MYR',
                        'label' => __('MYR', ECC_PLG_NAME),),
                    array(
                        'value' => 'SGD',
                        'label' => __('SGD', ECC_PLG_NAME),),
                    array(
                        'value' => 'CNY',
                        'label' => __('CNY', ECC_PLG_NAME),),
                    array(
                        'value' => 'USD',
                        'label' => __('USD', ECC_PLG_NAME),),
                    array(
                        'value' => 'INR',
                        'label' => __('INR', ECC_PLG_NAME),),
                    array(
                        'value' => 'BGN',
                        'label' => __('BGN', ECC_PLG_NAME),),
                    array(
                        'value' => 'IDR',
                        'label' => __('IDR', ECC_PLG_NAME),),
                    array(
                        'value' => 'CHF',
                        'label' => __('CHF', ECC_PLG_NAME),),
                    array(
                        'value' => 'SEK',
                        'label' => __('SEK', ECC_PLG_NAME),),
                    array(
                        'value' => 'CZK',
                        'label' => __('CZK', ECC_PLG_NAME),),
                    array(
                        'value' => 'BRL',
                        'label' => __('BRL', ECC_PLG_NAME),),
                    array(
                        'value' => 'PHP',
                        'label' => __('PHP', ECC_PLG_NAME),),
                    array(
                        'value' => 'MXN',
                        'label' => __('MXN', ECC_PLG_NAME),),
                    array(
                        'value' => 'ZAR',
                        'label' => __('ZAR', ECC_PLG_NAME),),
                    array(
                        'value' => 'PLN',
                        'label' => __('PLN', ECC_PLG_NAME),),
                    array(
                        'value' => 'NZD',
                        'label' => __('NZD', ECC_PLG_NAME),),
                    array(
                        'value' => 'KRW',
                        'label' => __('KRW', ECC_PLG_NAME),),
                    array(
                        'value' => 'RON',
                        'label' => __('RON', ECC_PLG_NAME),),
                    array(
                        'value' => 'THB',
                        'label' => __('THB', ECC_PLG_NAME),),
                    array(
                        'value' => 'RUB',
                        'label' => __('RUB', ECC_PLG_NAME),),
                    array(
                        'value' => 'GBP',
                        'label' => __('GBP', ECC_PLG_NAME),),
                ),
            'default' => array(
                'USD',
            ),
        ),

        // Default 2st Currency
        array(
            'type' => 'select',
            'name' => 'ecc_second_currency',
            'label' => __('Default Base Currency', ECC_PLG_NAME),
            'items' => array(
                array(
                    'value' => 'CAD',
                    'label' => __('CAD', ECC_PLG_NAME),),
                array(
                    'value' => 'DKK',
                    'label' => __('DKK', ECC_PLG_NAME),),
                array(
                    'value' => 'AUD',
                    'label' => __('AUD', ECC_PLG_NAME),),
                array(
                    'value' => 'EUR',
                    'label' => __('EUR', ECC_PLG_NAME),),
                array(
                    'value' => 'HUF',
                    'label' => __('HUF', ECC_PLG_NAME),),
                array(
                    'value' => 'JPY',
                    'label' => __('JPY', ECC_PLG_NAME),),
                array(
                    'value' => 'HKD',
                    'label' => __('HKD', ECC_PLG_NAME),),
                array(
                    'value' => 'NOK',
                    'label' => __('NOK', ECC_PLG_NAME),),
                array(
                    'value' => 'ILS',
                    'label' => __('ILS', ECC_PLG_NAME),),
                array(
                    'value' => 'HRK',
                    'label' => __('HRK', ECC_PLG_NAME),),
                array(
                    'value' => 'ISK',
                    'label' => __('ISK', ECC_PLG_NAME),),
                array(
                    'value' => 'TRY',
                    'label' => __('TRY', ECC_PLG_NAME),),
                array(
                    'value' => 'MYR',
                    'label' => __('MYR', ECC_PLG_NAME),),
                array(
                    'value' => 'SGD',
                    'label' => __('SGD', ECC_PLG_NAME),),
                array(
                    'value' => 'CNY',
                    'label' => __('CNY', ECC_PLG_NAME),),
                array(
                    'value' => 'USD',
                    'label' => __('USD', ECC_PLG_NAME),),
                array(
                    'value' => 'INR',
                    'label' => __('INR', ECC_PLG_NAME),),
                array(
                    'value' => 'BGN',
                    'label' => __('BGN', ECC_PLG_NAME),),
                array(
                    'value' => 'IDR',
                    'label' => __('IDR', ECC_PLG_NAME),),
                array(
                    'value' => 'CHF',
                    'label' => __('CHF', ECC_PLG_NAME),),
                array(
                    'value' => 'SEK',
                    'label' => __('SEK', ECC_PLG_NAME),),
                array(
                    'value' => 'CZK',
                    'label' => __('CZK', ECC_PLG_NAME),),
                array(
                    'value' => 'BRL',
                    'label' => __('BRL', ECC_PLG_NAME),),
                array(
                    'value' => 'PHP',
                    'label' => __('PHP', ECC_PLG_NAME),),
                array(
                    'value' => 'MXN',
                    'label' => __('MXN', ECC_PLG_NAME),),
                array(
                    'value' => 'ZAR',
                    'label' => __('ZAR', ECC_PLG_NAME),),
                array(
                    'value' => 'PLN',
                    'label' => __('PLN', ECC_PLG_NAME),),
                array(
                    'value' => 'NZD',
                    'label' => __('NZD', ECC_PLG_NAME),),
                array(
                    'value' => 'KRW',
                    'label' => __('KRW', ECC_PLG_NAME),),
                array(
                    'value' => 'RON',
                    'label' => __('RON', ECC_PLG_NAME),),
                array(
                    'value' => 'THB',
                    'label' => __('THB', ECC_PLG_NAME),),
                array(
                    'value' => 'RUB',
                    'label' => __('RUB', ECC_PLG_NAME),),
                array(
                    'value' => 'GBP',
                    'label' => __('GBP', ECC_PLG_NAME),),
            ),
            'default' => array(
                'EUR',
            ),
            'dependency' => array(
                'field' => 'ecc_layout',
                'function' => 'ecc_has_two_curr',
            ),
        ),

        // Exclude Currency
        array(
            'type' => 'multiselect',
            'name' => 'ecc_exclude_currency',
            'label' => __('Select Currencies to be excluded', ECC_PLG_NAME),
            'items' => array(
                array(
                    'value' => 'CAD',
                    'label' => __('CAD', ECC_PLG_NAME),),
                array(
                    'value' => 'DKK',
                    'label' => __('DKK', ECC_PLG_NAME),),
                array(
                    'value' => 'AUD',
                    'label' => __('AUD', ECC_PLG_NAME),),
                array(
                    'value' => 'EUR',
                    'label' => __('EUR', ECC_PLG_NAME),),
                array(
                    'value' => 'HUF',
                    'label' => __('HUF', ECC_PLG_NAME),),
                array(
                    'value' => 'JPY',
                    'label' => __('JPY', ECC_PLG_NAME),),
                array(
                    'value' => 'HKD',
                    'label' => __('HKD', ECC_PLG_NAME),),
                array(
                    'value' => 'NOK',
                    'label' => __('NOK', ECC_PLG_NAME),),
                array(
                    'value' => 'ILS',
                    'label' => __('ILS', ECC_PLG_NAME),),
                array(
                    'value' => 'HRK',
                    'label' => __('HRK', ECC_PLG_NAME),),
                array(
                    'value' => 'ISK',
                    'label' => __('ISK', ECC_PLG_NAME),),
                array(
                    'value' => 'TRY',
                    'label' => __('TRY', ECC_PLG_NAME),),
                array(
                    'value' => 'MYR',
                    'label' => __('MYR', ECC_PLG_NAME),),
                array(
                    'value' => 'SGD',
                    'label' => __('SGD', ECC_PLG_NAME),),
                array(
                    'value' => 'CNY',
                    'label' => __('CNY', ECC_PLG_NAME),),
                array(
                    'value' => 'USD',
                    'label' => __('USD', ECC_PLG_NAME),),
                array(
                    'value' => 'INR',
                    'label' => __('INR', ECC_PLG_NAME),),
                array(
                    'value' => 'BGN',
                    'label' => __('BGN', ECC_PLG_NAME),),
                array(
                    'value' => 'IDR',
                    'label' => __('IDR', ECC_PLG_NAME),),
                array(
                    'value' => 'CHF',
                    'label' => __('CHF', ECC_PLG_NAME),),
                array(
                    'value' => 'SEK',
                    'label' => __('SEK', ECC_PLG_NAME),),
                array(
                    'value' => 'CZK',
                    'label' => __('CZK', ECC_PLG_NAME),),
                array(
                    'value' => 'BRL',
                    'label' => __('BRL', ECC_PLG_NAME),),
                array(
                    'value' => 'PHP',
                    'label' => __('PHP', ECC_PLG_NAME),),
                array(
                    'value' => 'MXN',
                    'label' => __('MXN', ECC_PLG_NAME),),
                array(
                    'value' => 'ZAR',
                    'label' => __('ZAR', ECC_PLG_NAME),),
                array(
                    'value' => 'PLN',
                    'label' => __('PLN', ECC_PLG_NAME),),
                array(
                    'value' => 'NZD',
                    'label' => __('NZD', ECC_PLG_NAME),),
                array(
                    'value' => 'KRW',
                    'label' => __('KRW', ECC_PLG_NAME),),
                array(
                    'value' => 'RON',
                    'label' => __('RON', ECC_PLG_NAME),),
                array(
                    'value' => 'THB',
                    'label' => __('THB', ECC_PLG_NAME),),
                array(
                    'value' => 'RUB',
                    'label' => __('RUB', ECC_PLG_NAME),),
                array(
                    'value' => 'GBP',
                    'label' => __('GBP', ECC_PLG_NAME),),
            ),
            'default' => array(
                '',
            ),
            'dependency' => array(
                'field' => 'ecc_layout',
                'function' => 'ecc_has_multi_curr',
            ),
        ),

        array(
            'type' => 'toggle',
            'name' => 'ecc_change_first_currency',
            'label' => __('Allow Change First Currency', ECC_PLG_NAME),
            'description' => __('Allow/Disallow users to change first currency', ECC_PLG_NAME),
            'default' => '1',
        ),

        array(
            'type' => 'toggle',
            'name' => 'ecc_change_second_currency',
            'label' => __('Allow Change Second Currency', ECC_PLG_NAME),
            'description' => __('Allow/Disallow users to change second currency', ECC_PLG_NAME),
            'default' => '1',
            'dependency' => array(
                'field' => 'ecc_layout',
                'function' => 'ecc_has_two_curr',
            ),
        ),
	),
);

// Project Basic Setup
$ecc_converter_style =
    array(
        'id'          => 'ecc_style_meta',
        'types'       => array('ecc-converters'),
        'title'       => __('Converter Styling', ECC_PLG_NAME),
        'priority'    => 'high',
        'template'    => array(

            array(
                'type' => 'color',
                'name' => 'ecc_primary_color',
                'label' => __('Primary Color, leave empty for default', ECC_PLG_NAME),
            ),
            array(
                'type' => 'color',
                'name' => 'ecc_secondary_color',
                'label' => __('Secondary Color, leave empty for default', ECC_PLG_NAME),
            ),
            array(
                'type' => 'color',
                'name' => 'ecc_font_color',
                'label' => __('Font Color, leave empty for default', ECC_PLG_NAME),
            ),
            array(
                'type' => 'color',
                'name' => 'ecc_background_color',
                'label' => __('Box Background Color, leave empty for default', ECC_PLG_NAME),
            ),

            array(
                'type' => 'toggle',
                'name' => 'ecc_hide_header',
                'label' => __('Hide Box Header', ECC_PLG_NAME),
                'description' => __('Hide/Show header in the converter box', ECC_PLG_NAME),
                'default' => '0',
            ),

            array(
                'type' => 'toggle',
                'name' => 'ecc_hide_footer',
                'label' => __('Hide Box Footer', ECC_PLG_NAME),
                'description' => __('Hide/Show footer in the converter box (only applies in layout 1 and 3)', ECC_PLG_NAME),
                'default' => '0',
            ),

            array(
                'type' => 'select',
                'name' => 'ecc_font_face',
                'label' => __('Font Family', ECC_PLG_NAME),
                'description' => __('Select Font', ECC_PLG_NAME),
                'items' => array(
                    'data' => array(
                        array(
                            'source' => 'function',
                            'value' => 'vp_get_gwf_family',
                        ),
                    ),
                ),
            ),
            array(
                'type' => 'radiobutton',
                'name' => 'ecc_font_style',
                'label' => __('Font Style', ECC_PLG_NAME),
                'description' => __('Select Font Style', ECC_PLG_NAME),
                'items' => array(
                    'data' => array(
                        array(
                            'source' => 'binding',
                            'field' => 'ecc_font_face',
                            'value' => 'vp_get_gwf_style',
                        ),
                    ),
                ),
                'default' => array(
                    '{{first}}',
                ),
            ),
            array(
                'type' => 'radiobutton',
                'name' => 'ecc_font_weight',
                'label' => __('Font Weight', ECC_PLG_NAME),
                'description' => __('Select Font Weight', ECC_PLG_NAME),
                'items' => array(
                    'data' => array(
                        array(
                            'source' => 'binding',
                            'field' => 'ecc_font_face',
                            'value' => 'vp_get_gwf_weight',
                        ),
                    ),
                ),
            ),

        ),
    );





// INITIALIZATIONS

new VP_Metabox($ecc_converter);
new VP_Metabox($ecc_converter_style);