<?php
/*
Plugin Name: Easy Currency Converter
Plugin URI: https://easycurrencyconverter.net
Description: Plugin for currency convertion
Author URI: https://easycurrencyconverter.net
Tested up to: 5.2.2
License: http://www.gnu.org/licenses/gpl-2.0.html
Author: Easy Currency Converter
Version: 1.4
*/

function ecc_converter_short( $atts, $content = null ) {

	// CSS Libs
	wp_enqueue_style( 'ecc-bootstrap' );
	wp_enqueue_style( 'ecc-bootstrap-vue' );
	wp_enqueue_style( 'ecc-style' );


	// WP jQuery
	wp_enqueue_script( "jquery" );

	// JS Main Script
	wp_enqueue_script( 'ecc-vendor-chunk' );
	wp_enqueue_script( 'ecc-bundle' );

	// Extract Attributes
	extract( shortcode_atts( array( 'id' => '' ), $atts ) );

	// Check Layout
	if ( ! $id || 'publish' != get_post_status( $id ) ) {
		return __( 'We are sorry but the Converter you selected does not exixt or isn\'t publish yet', ECC_PLG_NAME );
	}

	// Layout Options
	$meta  = vp_metabox( 'ecc_basic_meta', '', $id );
	$style = vp_metabox( 'ecc_style_meta', '', $id );

	$font_face   = isset( $style->meta['ecc_font_face'] ) &&
	               ! empty( $style->meta['ecc_font_face'] ) ?
		$style->meta['ecc_font_face'] : '';
	$font_style  = isset( $style->meta['ecc_font_style'] ) &&
	               ! empty( $style->meta['ecc_font_style'] ) ?
		$style->meta['ecc_font_style'] : '';
	$font_weight = isset( $style->meta['ecc_font_weight'] ) &&
	               ! empty( $style->meta['ecc_font_weight'] ) ?
		$style->meta['ecc_font_weight'] : '';

	$primaryColor    = isset( $style->meta['ecc_primary_color'] ) &&
	                   ! empty( $style->meta['ecc_primary_color'] ) ?
		$style->meta['ecc_primary_color'] : '';
	$secondaryColor  = isset( $style->meta['ecc_secondary_color'] ) &&
	                   ! empty( $style->meta['ecc_secondary_color'] ) ?
		$style->meta['ecc_secondary_color'] : '';
	$fontColor       = isset( $style->meta['ecc_font_color'] ) &&
	                   ! empty( $style->meta['ecc_font_color'] ) ?
		$style->meta['ecc_font_color'] : '';
	$backgroundColor = isset( $style->meta['ecc_background_color'] ) &&
	                   ! empty( $style->meta['ecc_background_color'] ) ?
		$style->meta['ecc_background_color'] : '';

	VP_Site_GoogleWebFont::instance()->add( $font_face, $font_weight, $font_style );
	VP_Site_GoogleWebFont::instance()->register_and_enqueue();

	$custom_css = "
                #ecc_{$id}.card.ecc-container{
                    border-color: {$secondaryColor};
                    background-color: {$backgroundColor};
                    color: {$fontColor};
                    font-family: {$font_face}
                }
                #ecc_{$id}.card.ecc-container > .card-header:first-child{
                    border-color: {$secondaryColor};
                }
                #ecc_{$id}.card.ecc-container .card,
                #ecc_{$id}.card.ecc-container .card > .card-footer:last-child{
                    border-color: {$primaryColor}
                }
                #ecc_{$id}.card.ecc-container .input-group-text,
                #ecc_{$id}.card.ecc-container .input-group>.form-control,
                #ecc_{$id}.card.ecc-container .dropdown-toggle{
                    border-color: {$primaryColor};
                }
                #ecc_{$id}.card.ecc-container .input-group-text,
                #ecc_{$id}.card.ecc-container .card > .card-footer:last-child,
                #ecc_{$id}.card.ecc-container .btn-outline-secondary:hover{
                    background-color: {$primaryColor};
                }
                #ecc_{$id}.card.ecc-container .input-group-text{
                    color: {$fontColor}
                }";

	wp_add_inline_style( 'ecc-style', $custom_css );

	$vue_atts = esc_attr( json_encode( [
		'id'             => $id,
		'title'          => get_the_title( $id ),
		'layout'         => isset( $meta->meta['ecc_layout'] ) &&
		                    ! empty( $meta->meta['ecc_layout'] ) ?
			$meta->meta['ecc_layout'] : '1',
		'firstCurrency'  => isset( $meta->meta['ecc_first_currency'] ) &&
		                    ! empty( $meta->meta['ecc_first_currency'] ) ?
			$meta->meta['ecc_first_currency'] : 'USD',
		'secondCurrency' => isset( $meta->meta['ecc_second_currency'] ) &&
		                    ! empty( $meta->meta['ecc_second_currency'] ) ?
			$meta->meta['ecc_second_currency'] : 'EUR',

		'excludeCurrency'           => isset( $meta->meta['ecc_exclude_currency'] ) &&
		                               ! empty( $meta->meta['ecc_exclude_currency'] ) ?
			$meta->meta['ecc_exclude_currency'] : '',
		'allowChangeFirstCurrency'  => isset( $meta->meta['ecc_change_first_currency'] ) &&
		                               ! empty( $meta->meta['ecc_change_first_currency'] ) ?
			$meta->meta['ecc_change_first_currency'] : '',
		'allowChangeSecondCurrency' => isset( $meta->meta['ecc_change_second_currency'] ) &&
		                               ! empty( $meta->meta['ecc_change_second_currency'] ) ?
			$meta->meta['ecc_change_second_currency'] : '',

		'hideHeader' => isset( $style->meta['ecc_hide_header'] ) &&
		                ! empty( $style->meta['ecc_hide_header'] ) ?
			$style->meta['ecc_hide_header'] : '',
		'hideFooter' => isset( $style->meta['ecc_hide_footer'] ) &&
		                ! empty( $style->meta['ecc_hide_footer'] ) ?
			$style->meta['ecc_hide_footer'] : '',
	] ) );

	$html = '';
	require( ECC_DIR . 'inc/views/ecc-converter.php' );

	// Return HTML
	return $html;
}

add_shortcode( 'ecc_converter', 'ecc_converter_short' );
