<?php
/*
Element Description: Easy Currency Converter
*/

// Block Class
class eccConverter extends WPBakeryShortCode {

    // Class Init
    function __construct() {
        add_action( 'init', array( $this, 'ecc_converter_map' ) );
        add_shortcode( 'ecc_vc_converter', array( $this, 'ecc_converter_short' ) );
    }

    // Block Map
    public function ecc_converter_map() {

        // Stop all if VC is not enabled
        if ( !defined( 'WPB_VC_VERSION' ) ) {
            return;
        }

        // Map the block with vc_map()
        vc_map(
            array(
                'name' => esc_html__('Easy Currency Converter', ECC_PLG_NAME),
                'base' => 'ecc_converter',
                'description' => esc_html__('Add a Easy Currency Converter', ECC_PLG_NAME),
                'icon' => ECC_URL.'/assets/img/vc-icon.png',
                'params' => array(

                    // Select Layout
                    array(
                        'type' => 'dropdown',
                        'heading' => esc_html__('Converter', ECC_PLG_NAME),
                        'param_name' => 'id',
                        'value' => ecc_vc_converters_dropdown_data(),
                        'admin_label' => true,
                    ),

                ),
            )
        );


    } // End Block Map


    // Block Shortcode
    public function ecc_converter_short( $atts ) {

        extract(
            shortcode_atts(
                array(
                    'id' => '',
                ),
                $atts
            )
        );

        // Short HTML
        $result = do_shortcode('[ecc_converter id='.$id.']');

        // Return
        return $result;

    } // End Block Shortcode

} // End Block Class


// Block Init
new eccConverter();